--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_hcd.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_hcd.h	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,184 @@
+/* Name: mausb_hcd.h 
+ * Description: header file for mausb_hcd.c 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#ifndef __MAUSB_HCD_H 
+#define __MAUSB_HCD_H 
+ 
+#include <linux/spinlock.h> 
+ 
+#include "mausb_hub.h" 
+#include "mausb_pkt.h" 
+#include "mausb_mem.h" 
+#include "mausb_const.h" 
+ 
+#define MAUSB_NAME "mausb" 
+#define MAUSB_BUS "mausb" 
+ 
+#define mausb_info(mhcd, fmt, args...) \ 
+ dev_info(mausb_hcd_to_usb_hcd(mhcd)->self.controller , fmt , ## args) 
+#define mausb_dbg(mhcd, fmt, args...) \ 
+ dev_dbg(mausb_hcd_to_usb_hcd(mhcd)->self.controller , fmt , ## args) 
+#define mausb_warn(mhcd, fmt, args...) \ 
+ dev_warn(mausb_hcd_to_usb_hcd(mhcd)->self.controller , fmt , ## args) 
+#define mausb_err(mhcd, fmt, args...) \ 
+ dev_err(mausb_hcd_to_usb_hcd(mhcd)->self.controller , fmt , ## args) 
+ 
+/* Transfer directions */ 
+#define PIPE_DIR_OUT 0 
+#define PIPE_DIR_IN 1 
+ 
+/* Host BOS parameters */ 
+#define MAUSB_HOST_NUM_DEV_CAPS 1 
+#define MAUSB_HOST_U1_DEV_EXIT_LAT 0 
+#define MAUSB_HOST_U2_DEV_EXIT_LAT 0 
+ 
+/* TEMPORARY: the mausb device will have this handle */ 
+#define MAUSB_DEV_ADDR 0x54 
+#define MAUSB_MASS_ID 0x25 
+ 
+struct mausb_ms_drv; 
+ 
+/** 
+ * This structure holds the information set in a get bos descriptor request. 
+ * 
+ * @bos_des: Binary Object Store Descriptor, per USB2.0 Spec 
+ * @ss_cap_des: SuperSpeed Capability Descriptor, per USB3.0 Spec 
+ */ 
+struct __attribute__((__packed__)) mausb_host_bos { 
+ struct usb_bos_descriptor bos_des; 
+ struct usb_ss_cap_descriptor ss_cap_des; 
+}; 
+ 
+/** 
+ * This structure holds all of the MA USB-specific data. 
+ * 
+ * All data listed in this structure is protected by the hcd_lock. 
+ * if you want to use any of this data, you need to be in possession 
+ * of this lock. 
+ * 
+ * @root_hub: Contains all of the data for the USB 2.0 roothub. 
+ * This includes status, state and descriptors. 
+ * @shared_root_hub: Contains all of the data for the USB 3.0 roothub. 
+ * This includes status, state and descriptors 
+ * @host_bos: Stores the host's BOS descriptor 
+ * @udev: Pointer to the usb device we are currently sending 
+ * a packet to. 
+ * @shared_hcd: The second host controller structure for the MAUSB 
+ * driver. We need this because we do SuperSpeed, which 
+ * requires 2 root hubs. 
+ * @ma_dev: The connected MA USB device 
+ * @ma_hcd_task: Task for handling urb queue 
+ * @ma_hcd_task_data: Context for ma_hcd_task 
+ * @waitq: Event trigger for dequeue 
+ * @enqueue_urb_list: List of enqueued urbs from core 
+ * @transfer_urb_list: List of urbs awaiting ma transfer 
+ * @urb_list_lock: Lock for accessing urb lists 
+ * @hcd_lock: Lock for accessing data in this structure. note that 
+ * endpoints have their own locks. When accessing 
+ * endpoint data, this lock should NOT be held 
+ * @giveback_lock: spin lock to prevent preemption when give back an urb 
+ * @resuming: Set to 1 when HCD is resuming 
+ * @disabled: Set to 1 when hcd is disabled 
+ * @dev: Underlying device structure 
+ */ 
+struct __attribute__((__packed__)) mausb_hcd { 
+ struct mausb_root_hub root_hub; 
+ struct mausb_root_hub shared_root_hub; 
+ 
+ struct mausb_host_bos host_bos; 
+ 
+ struct usb_device *udev; 
+ 
+ struct usb_hcd *usb_hcd; 
+ struct usb_hcd *shared_hcd; 
+ 
+ struct ma_dev ma_dev; 
+ struct task_struct *ma_hcd_task; 
+ void *ma_hcd_task_data; 
+ wait_queue_head_t waitq; 
+ struct list_head enqueue_urb_list; 
+ struct list_head transfer_urb_list; 
+ spinlock_t urb_list_lock; 
+ spinlock_t hcd_lock; 
+ spinlock_t giveback_lock; 
+ unsigned int resuming:1; 
+ unsigned int disabled:1; 
+ 
+ struct device *dev; 
+}; 
+ 
+/* major and minor numbers for MA USB device */ 
+#define MAUSB_MAJOR 300 /* TODO: get real major number */ 
+#define MAUSB_MINOR 1 
+ 
+/* Pointer conversion functions */ 
+struct mausb_hcd *usb_hcd_to_mausb_hcd(struct usb_hcd *hcd); 
+struct usb_hcd *mausb_hcd_to_usb_hcd(struct mausb_hcd *mhcd); 
+struct device *mausb_hcd_to_dev(struct mausb_hcd *mhcd); 
+struct mausb_urb *usb_urb_to_mausb_urb(struct urb *urb); 
+ 
+/* URB handling functions */ 
+void mausb_unlink_giveback_urb(struct mausb_urb *maurb, int status); 
+ 
+/* Connection event function */ 
+int mausb_device_connect(int); 
+ 
+/* interfaces */ 
+int mausb_probe(struct device *dev); 
+int mausb_remove(struct device *dev); 
+ 
+ 
+#endif 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_hub.c linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_hub.c
